/*Ŀ
 ݳ                                                                      
 ݳ Program Name: TEST.PRG          Copyright: Gallagher Computing Corp. 
 ݳ Date Created: 03/21/93           Language: Clipper 5.2               
 ݳ Time Created: 00:57:08             Author: Kevin S Gallagher         
 
            */

#include "error.ch"

STATIC aDir_:={}, aReport_:={}

#define MC MAXCOL()
#define MR MAXROW()

#define MISSING_A_FILE    2

#xtranslate LSTRINT( <n> ) => LTRIM( STR( INT( <n> ) ) ) 

FUNCTION main
    LOCAL jj, kk, oldcolor := setcolor()
    OpenFiles()
    IF LEN( aDir_ ) <> 0
        setcolor("w+/b")
        ?replicate( chr(196),maxcol())
        // Show opened files
        AEVAL( aReport_, { | x | QOut( PADR( x, MC ) ) } )
        ?replicate( chr(196), MC )
        setcolor( oldcolor )
    ELSE
        ?"No Files found"
    ENDIF
RETURN NIL

FUNCTION OpenFiles
    LOCAL oError, bOldHandler, nLen :=0, aArr_ := {}, jj:=1

    IF ( nLen := LEN( aArr_ := DIRECTORY( "*.DBF" ) ) ) <> 0
        AEVAL(aArr_, { | x | AADD(aDir_, SUBS( x[1],1, AT(".",x[1])-1 ) ) } )

        // Install new errorhandler for opening files
        bOldhandler := ERRORBLOCK( { | oErr | Whathappen( oErr, .T. ) } )


        
        WHILE jj <> nLen +1
            BEGIN SEQUENCE
                // Try RDD DBFCDX
                USE ( aDir_[jj] ) VIA "DBFCDX" NEW         ;      jj++
            RECOVER  USING oError
                // Try RDD DBFNTX
                IF oError:subcode == 1012
                    USE ( aDir_[jj] ) VIA "DBFNTX" NEW     ;      jj++
                ELSE
                    EVAL( bOldhandler, oError )
                    QUIT
                ENDIF
            END SEQUENCE
            
            IF !empty( alias() )
                ALERT("ALIAS NAME --> "+ALIAS()+"; RDDNAME --> "+RDDNAME() )
                AADD(aReport_, PADR(" "+aDir_[jj -1],13) + ": Opened --> YES  RDDNAME --> "+RDDNAME() )
            ELSE
                AADD(aReport_, PADR(" "+aDir_[jj -1],13) + ": Opened -->  NO  RDDNAME --> N/A" )
            ENDIF
        ENDDO

        // Release local error handle and give control to the original
        ERRORBLOCK( bOldhandler )
        ASORT( aDir_ )
    ELSE
        ALERT("NO FILES TO OPEN")
        QUIT
    ENDIF
RETURN NIL

FUNCTION Whathappen( oErr, lLocal )
    LOCAL cFile, xErr, nChoice :=1, aErr_:={}, cTraceback:=""
    LOCAL oldcolor := setcolor("w+/r"), xMsg:= ""

    IF oErr:gencode == EG_OPEN .AND. oErr:osCode == MISSING_A_FILE
        xMsg:=oErr:description
        oErr:description:="Ooops "+xMsg+" on "+oErr:filename
        IF ( alert( "Yo I can not seem to find ;"+;
            oErr:filename,{" Quit "," Ignore "} ) ) ==1

            @12,0 say PADR(" gencode.....: "+ LSTRINT( oErr:gencode ) ,MC )
            @13,0 say PADR(" osCode......: "+ LSTRINT( oErr:osCode )  ,MC )
            @14,0 say PADR(" description.: "+ oErr:description        ,MC )
            @15,0 say PADR(" filename....: "+ oErr:filename           ,MC )
            QUIT
        ENDIF
        setcolor( oldcolor )
        RETURN .F.
    ENDIF

    // Change message in "subSystem"
    IF oErr:subsystem == "DBFCDX"
        xMsg:= "  Hey Lets try the DBFNTX RDDriver!"
    ENDIF

    IF EMPTY( ALLTRIM(oErr:operation ))
        oErr:operation:="Nada!"
    ENDIF

    // place some info into the array for showing on the console..
    AADD( aErr_, PADR(" gencode.....: "+ LSTRINT( oErr:gencode ) ,MC ) )
    AADD( aErr_, PADR(" description.: "+ oErr:description +xMsg  ,MC ) )
    AADD( aErr_, PADR(" osCode......: "+ LSTRINT( oErr:osCode )  ,MC ) )
    AADD( aErr_, PADR(" subCode.....: "+ LSTRINT( oErr:subCode ) ,MC ) )
    AADD( aErr_, PADR(" subsystem...: "+ oErr:subsystem          ,MC ) )
    AADD( aErr_, PADR(" operation...: "+ oErr:operation          ,MC ) )
    AADD( aErr_, PADR(" filename....: "+ oErr:filename           ,MC ) )

    // build a simple call trace back
    WHILE ( ! empty( procname( ++nChoice ) ) )
        cTraceback +=" "+LSTRINT( procline( nChoice ) )
    enddo
    AADD( aErr_, PADR(" TraceBack...:" +cTraceback               ,MC ) )

    // display the array of error info
    AEVAL( aErr_, { | x | QOut(x) } )
    setcolor(oldcolor)
    IF lLocal
        BREAK oErr
        RETURN NIL
    ENDIF
RETURN .T.



ANNOUNCE RDDSYS

PROCEDURE RDDINIT()
   REQUEST DBFNTX
   REQUEST DBFCDX
RETURN

INIT PROCEDURE HaHa
    CLS
    @0,0 say PADC("Clipper 5.2 Replacement Database Driver test",MC) color "w+/gr"
RETURN

EXIT PROCEDURE SoLong
    DBCLOSEALL()
    SETCOLOR("W/N")
RETURN
